<?php

class Application_Model_Vote
{
  protected $_username;
  protected $_restaurantname;
  protected $_votedate;
  protected $_id;

  public function __construct(array $options = null)
  {
    if (is_array($options)) {
      $this->setOptions($options);
    }
  }

  public function __set($name, $value)
  {
    $method = 'set' . $name;
    if (('mapper' == $name) || !method_exists($this, $method)) {
      throw new Exception('Invalid vote property');
    }
    $this->$method($value);
  }

  public function __get($name)
  {
    $method = 'get' . $name;
    if (('mapper' == $name) || !method_exists($this, $method)) {
      throw new Exception('Invalid vote property');
    }
    return $this->$method();
  }

  public function setOptions(array $options)
  {
    $methods = get_class_methods($this);
    foreach ($options as $key => $value) {
      $method = 'set' . ucfirst($key);
      if (in_array($method, $methods)) {
        $this->$method($value);
      }
    }
    return $this;
  }

  public function setUsername($text)
  {
    $this->_username = (string)$text;
    return $this;
  }

  public function getUsername()
  {
    return $this->_username;
  }

  public function setRestaurantname($text)
  {
    $this->_restaurantname = (string)$text;
    return $this;
  }

  public function getRestaurantname()
  {
    return $this->_restaurantname;
  }

  public function setVotedate($ts)
  {
    $this->_votedate = $ts;
    return $this;
  }

  public function getVotedate()
  {
    return $this->_votedate;
  }

  public function setId($id)
  {
    $this->_id = (int)$id;
    return $this;
  }

  public function getId()
  {
    return $this->_id;
  }


}

